#include <raylib.h>
#include <vector>
#include <cmath>
using namespace std;
float cas = -1;
int limit = 30;
float gravity = 300;
int height = 800;
int width = 800;
float casovac = 3;
class Star{
public:
    Star(float iny, float inx, float insize, float mousex, float mousey){
        size = insize;
        y=iny+insize;
        x=inx+insize;
         // Výpočet času k dosažení cíle
        float dy = mousey - y;
        float time = sqrt((2 * dy) / gravity);  // čas k dosažení cílové výšky
        
        // Výpočet horizontální rychlosti
        float dx = mousex - x;
        velocity_x = dx / time;  // rovnoměrný pohyb v ose x
        //velocity_x = (mousex-x)/(sqrt((2*((mousey-y)*30))/gravity)); //proč to nefunguje???
    }
    float size;
    float x;
    float y;
    float direction = -1;
    float velocity_y = 0, velocity_x;
    void update(float dt);
    void draw();
};
class Terc{
public:
    float radius = 17;
    Terc(float inny, float innx){
        x= innx;
        y= inny;
    }
    float rychlost_terce = 3;
    float x,y;
    int score = -1;
    float zmena_terce = rychlost_terce;
    void update(float dt);
    void draw();
    void well_done();
};
Terc terc = Terc(terc.radius, terc.radius);

void Star::update(float dt){
    float distance_y = fabs(terc.y - y);
    float distance_x = fabs(terc.x - x);
    float distance_sum = sqrt(distance_y*distance_y+distance_x*distance_x);
    if (distance_sum <= terc.radius+size){
        terc.well_done();
    }

    velocity_y += dt*gravity;
    if (y<=size){
        velocity_y *=-0.9; //ztráta energie při odrazu
        y=size;
    } else if (y>=height-size){
        velocity_y *=-0.9;
        y=height-size;
    }
    y += velocity_y * dt;
    x += velocity_x * dt;
}
void Star::draw(){
    DrawCircle(x,y,size, WHITE);
}
vector <Star> stars;



void Terc::update(float dt){
    if (zmena_terce >= rychlost_terce){
        y = radius+rand() % (height-int(2*radius)+1);
        x = radius+rand() % (width-int(2*radius)+1);
        zmena_terce=0;
        rychlost_terce = 1+rand() %5;
    }
    zmena_terce += dt;
}
void Terc::well_done(){
    score ++;
    y = radius+rand() % (height-int(2*radius)+1);
    x = radius+rand() % (width-int(2*radius)+1);
    zmena_terce=0;
    rychlost_terce = 1+rand() %5;
}
void Terc::draw(){
    DrawCircle(x,y, radius, GREEN);
}

void aktualne(float dt){
    if (IsKeyDown(KEY_SPACE) && casovac >= 1){
        float random_velikost = rand()%11 + 10;
        stars.push_back(Star(0, 0,random_velikost, GetMouseX(), GetMouseY()));
        casovac = 0;
    }
    casovac+=dt;
    cas+=dt;
}

int main() 
{
    float sipky = 0.1;
    int limit_predtim;
    InitWindow(width, height, "Test okno");
    while (!WindowShouldClose())
    {
        float dt = GetFrameTime();
        BeginDrawing();
        ClearBackground(LIGHTGRAY);
        if ( cas >=0 && cas < limit){
            for (int i=0; i<stars.size(); i++){
                stars[i].update(dt);
                stars[i].draw();
            }
            const char* text = TextFormat("%d", terc.score);
            DrawText(text, width - 80, 40, 30,BLACK);
            const char* cas_text = TextFormat("%d", limit-int(cas)+(int(cas)%1));
            DrawText(cas_text, width - 80, 80, 30,BLACK);
            terc.update(dt);
            terc.draw();
            aktualne(dt);
            limit_predtim = limit;
        } else{
            for (int i=0; i<stars.size(); i++){
                stars.pop_back();
            }
            if (terc.score >=0){
                DrawText("tvoje skore pri limitu ", 100, 25, 20,BLACK);
                const char* limit_text = TextFormat("%d", limit_predtim);
                DrawText(limit_text, 317, 25, 20,BLACK);
                const char* text = TextFormat("%d", terc.score);
                DrawText(text, 100, 50, 100,BLACK);
            }
            DrawText("hraj", 100, 200, 100, BLACK);
            DrawRectangleLines(75, 175,250,150, BLACK);
            const char* limit_aktual_text = TextFormat("%d", limit);
            DrawText(limit_aktual_text, 100, 400, 100,BLACK);
            DrawText("zvys casovac sipkou nahoru, sniz sipkou dolu", 100,550,20, BLACK);
            DrawText("Mezernikem strilis, sipkou navadis - stref se do zelenych tercu", 100,600,20, BLACK);
            if (IsKeyDown(KEY_UP) && sipky >= 0.1) limit += 1, sipky = 0;
            if (IsKeyDown(KEY_DOWN) && sipky >= 0.1) limit -= 1, sipky = 0;
            limit = fabs(limit);
            if (IsMouseButtonPressed(MOUSE_BUTTON_LEFT)){   
                cas = 0;
                terc.score = 0;
            }
            sipky += GetFrameTime();
        }
        EndDrawing();
    }

    CloseWindow();
    return 0;
}
